<?php

defined('BASEPATH') OR exit('No direct script access allowed');

class Texttestimonial extends CI_Controller 
{
    public function __construct() 
    {
        parent::__construct();   
        $this->load->library('session');
        $allowed_methods = ['api_text_testimonials'];
        if (!in_array($this->router->fetch_method(), $allowed_methods) && $this->session->userdata('validated') != true)
        {
            redirect('login');
        }     
        $this->load->helper('url');
        $this->load->model('Testimonials_Model');
        $this->load->model('Testimonials_Model','category');  
    }
public function api_text_testimonials()
{
    header("Access-Control-Allow-Origin: *");
    header("Content-Type: application/json");

    $query = $this->db
        ->where('status', '1')
        ->where('publish', '1')
        ->where('type', 't')
        ->order_by('sequence_no', 'ASC')
        ->get(TBL_TESTIMONIALS);

    $data = [];

   foreach ($query->result() as $row) {
    $data[] = [
        "id" => $row->id,
        "patient_name" => $row->patient_name,
        "treatment" => $row->treatment,
        "description" => $row->description,
        "image_url" => base_url("../assets/images/testimonials/" . $row->image),
        "sequence_no" => $row->sequence_no 
    ];
}


    echo json_encode([
        "status" => "success",
        "data" => $data
    ]);
    exit;
}

    public function index() 
    {
        $this->load->helper('url');        
        $data["extra_js"] = array("texttestimonial");
        $data['controller'] = base_url('home-slider/add');
        $data['page_title'] = "Manage Text Testimonial | CMS - Vinayak Webtech +91 90336 22526";
        $data['page_heading'] = "Manage Text Testimonial";
        $data['main_content'] = 'texttestimonial';
        $this->load->view('main_content', $data); 
        // $data['main_content'] = 'Slider/List_View';
        // $this->load->view('Slider/List_View', $data);
    }  

public function submit()
{
    date_default_timezone_set('Asia/Calcutta'); 
    $get_id = $this->input->post('id'); 
    
    $this->load->library('upload');
    $photo = "";      
     
    if(!empty($_FILES['file']['name']))
    {
        $this->upload->initialize($this->set_upload_options()); 
        if($this->upload->do_upload('file'))
        { 
            $photo_Data = $this->upload->data(); 
            $photo = $photo_Data['file_name'];
        }
        else
        { 
            $error = $this->upload->display_errors();
            $response = array("status" => "error", "heading" => "Upload Error", "message" => $error);
            echo json_encode($response);
            die;
        }
    }
    
    $get_old_doc = $this->input->post('get_old_doc'); 
 
    if(!empty($photo) && empty($get_id))
    {
        
        $doc_path = $photo;
    } 
    else if(empty($photo) && $get_id > 0)
    { 
        
        $doc_path = $get_old_doc;
    }
    else if(!empty($photo) && $get_id > 0)
    {
        
        if(!empty($get_old_doc) && file_exists(TESTIMONIALS_PATH."/".$get_old_doc))
        {
            unlink(TESTIMONIALS_PATH."/".$get_old_doc);
        }
        $doc_path = $photo;
    }        
    else
    {
        $doc_path = $photo;
    }

    if($get_id > 0)
    { 
        $data = array(
            'patient_name' => ucwords(strtolower($this->input->post('patient_name'))),  
            'treatment' => $this->input->post('treatment'),
            'sequence_no' => $this->input->post('sequence_no'), 
            'description' => $this->input->post('description'), 
            // 'update_uid' => $this->session->userdata('user_id'),
            // 'update_date' => date("Y-m-d H:i:s"),  
        );
         
        if(!empty($doc_path)) {
            $data['image'] = $doc_path;
        }
        
        $this->category->update(array('id' => $get_id), $data); 
        $response = array("status" => "ok", "heading" => "Updated", "message" => "Data Updated Successfully.");
    }
    else
    {
        $data = array(
            'patient_name' => ucwords(strtolower($this->input->post('patient_name'))), 
            'treatment' => $this->input->post('treatment'),
            'sequence_no' => $this->input->post('sequence_no'), 
            'description' => $this->input->post('description'), 
            'image' => $doc_path,  
            'add_uid' => $this->session->userdata('user_id'),
            'add_date' => date("Y-m-d H:i:s"),
            'date' => date("Y-m-d"),
            'time' => date("H:i:s"), 
        );
        $insert = $this->category->save($data);  

        $response = array("status" => "ok", "heading" => "Added", "message" => "Data Added Successfully.");
    }
     
    echo json_encode($response);
    die;        
}

private function set_upload_options()
{   
    $config = array();
    $config['upload_path'] = TESTIMONIALS_PATH; 
    $config['allowed_types'] = 'jpeg|jpg|png';
    $config['max_width'] = 0;
    $config['max_height'] = 0;
    $config['max_size'] = '1024';  
    $config['encrypt_name'] = TRUE; 
    return $config;
}

    public function list()
    { 
        $list = $this->category->get_datatables();
        $data = array();
        $no = $_POST['start'] + 1;
        foreach ($list as $category) {
            $row = array();
            $row[] = $no++; 
            $row[] = $category->patient_name;
            $row[] = $category->treatment;
            $row[] = '<div>'.$category->description.'</div>';
            $row[] = $category->sequence_no; 

            $img_path = TESTIMONIALS_PATH . "/" .$category->image;
                $row[] = "<img src='".$img_path."' style='width:auto; height:50px;' />"; 

            $row[] = date("d-m-Y g:i A", strtotime($category->add_date));
            $url = base_url();  
            if($category->status == '1')
                $row[] = '<a class="label orange-bg active-btn" href="javascript:void(0)" title="Active" onclick="deactive('."'".$category->id."'".')"><span class="badge badge-success">Active</span></a>';   
            else
                $row[] = '<a class="label red-bg deactive-btn" href="javascript:void(0)" title="Deactive" onclick="active('."'".$category->id."'".')"><span class="badge badge-danger">Deactive</span></a>';

            $row[] = '<a type="button" href="javascript:void(0);" onclick="edit_data('."'".$category->id."'".')" class="edit_btn btn btn-sm btn-icon" title="Edit Record"><svg xmlns="http://www.w3.org/2000/svg" width="24" height="24" viewBox="0 0 24 24" class="eva eva-edit-2-outline"><g data-name="Layer 2"><g data-name="edit-2"><rect width="24" height="24" opacity="0"></rect><path d="M19 20H5a1 1 0 0 0 0 2h14a1 1 0 0 0 0-2z"></path><path d="M5 18h.09l4.17-.38a2 2 0 0 0 1.21-.57l9-9a1.92 1.92 0 0 0-.07-2.71L16.66 2.6A2 2 0 0 0 14 2.53l-9 9a2 2 0 0 0-.57 1.21L4 16.91a1 1 0 0 0 .29.8A1 1 0 0 0 5 18zM15.27 4L18 6.73l-2 1.95L13.32 6zm-8.9 8.91L12 7.32l2.7 2.7-5.6 5.6-3 .28z"></path></g></g></svg></a>
                <a type="button" class="delete_btn btn btn-sm btn-icon" href="javascript:" title="Delete Record" data-id="'.$category->id.'"><svg xmlns="http://www.w3.org/2000/svg" width="24" height="24" viewBox="0 0 24 24" class="eva eva-trash-2-outline"><g data-name="Layer 2"><g data-name="trash-2"><rect width="24" height="24" opacity="0"></rect><path d="M21 6h-5V4.33A2.42 2.42 0 0 0 13.5 2h-3A2.42 2.42 0 0 0 8 4.33V6H3a1 1 0 0 0 0 2h1v11a3 3 0 0 0 3 3h10a3 3 0 0 0 3-3V8h1a1 1 0 0 0 0-2zM10 4.33c0-.16.21-.33.5-.33h3c.29 0 .5.17.5.33V6h-4zM18 19a1 1 0 0 1-1 1H7a1 1 0 0 1-1-1V8h12z"></path><path d="M9 17a1 1 0 0 0 1-1v-4a1 1 0 0 0-2 0v4a1 1 0 0 0 1 1z"></path><path d="M15 17a1 1 0 0 0 1-1v-4a1 1 0 0 0-2 0v4a1 1 0 0 0 1 1z"></path></g></g></svg></a>';
            $data[] = $row;
        }
        $output = array(
                        "draw" => $_POST['draw'],
                        "recordsTotal" => $this->category->count_all(),
                        "recordsFiltered" => $this->category->count_filtered(),
                        "data" => $data,
                ); 
        echo json_encode($output);
    }

   public function edit($id)
{
    $row = $this->category->get_by_id($id);

    $data = array(
        'id' => $row->id,
        'patient_name' => $row->patient_name,
        'treatment' => $row->treatment,
        'description' => $row->description,
        'image' => $row->image,
        'sequence_no' => $row->sequence_no
    );

    echo json_encode($data);
}


    public function active($id)
    {
        $data = array();
        $sql = "update ". TBL_MGT_TEAM ." set status='1' where id ='".$id."'";       
        $res = $this->db->query($sql);
        $data[] = "sucess";
        die(json_encode($data));
    }

    public function deactive($id)
    {
        $data = array();
        $sql = "update ". TBL_MGT_TEAM ." set status='0' where id ='".$id."'";       
        $res = $this->db->query($sql);
        $data[] = "sucess";
        die(json_encode($data));
    }

    public function delete($id)
    {
        $get_id = $id; 
        $sql_query = $this->db->query("select id, image, publish from ". TBL_MGT_TEAM ." where id='$get_id' and publish='1'")->row(); 
        if (isset($sql_query))
        {   
            $image =  $sql_query->image;
            if(!empty($sql_query->image))
            {
                $image_file_path = TESTIMONIALS_PATH . "/" . $image; 
                unlink($image_file_path);
            }
        }
        $response = array("status" => "ok", "heading" => "Deleted", "message" => "Record Delete Successfully.", "tbc_name" => "");
        $this->category->delete_by_id($get_id);  
        echo json_encode($response);  
        die;
    }
 
    public function api_home_slider()
    {
        header("Access-Control-Allow-Origin: *");
        header("Content-Type: application/json");

        $query = $this->db
            ->where('status', '1')
            ->order_by('sequence_no', 'ASC')
            ->get(TBL_MGT_TEAM);

        $data = [];
        foreach ($query->result() as $row) {
            $data[] = [
                "id" => $row->id,
                "patient_name" => $row->patient_name,
                
                "image_url" => base_url()."../assets/images/slider/" . $row->image,
            ];
        }

        echo json_encode([
            "status" => "success",
            "data" => $data
        ]);
        exit;
    }

}
